質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.52%

cryptographyのインストール時のエラー(python)

解決済

回答 1

投稿

  • 評価
  • クリップ 0
  • VIEW 5,072

tug

score 5

やりたいこと

pythonでssh接続をしたく、paramikoを利用したいのですが、import時にエラーが発生してしまいます。
このエラーをなくしたいです。

Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  File "/usr/local/python/lib/python3.4/site-packages/paramiko/__init__.py", line 30, in <module>
    from paramiko.transport import SecurityOptions, Transport
  File "/usr/local/python/lib/python3.4/site-packages/paramiko/transport.py", line 32, in <module>
    from cryptography.hazmat.backends import default_backend
ImportError: No module named 'cryptography'

エラー内容

cryptographyをインストールすればよいのかと思い、

pip install cryptography

を実行すると以下のエラーが発生し、インストールできません。

Downloading/unpacking cryptography
  Downloading cryptography-1.4.tar.gz (399kB): 399kB downloaded
  Running setup.py (path:/tmp/pip_build_root/cryptography/setup.py) egg_info for package cryptography

    no previously-included directories found matching 'docs/_build'
    warning: no previously-included files matching '*' found under directory 'vectors'
Downloading/unpacking idna>=2.0 (from cryptography)
  Downloading idna-2.1-py2.py3-none-any.whl (54kB): 54kB downloaded
Requirement already satisfied (use --upgrade to upgrade): pyasn1>=0.1.8 in /usr/local/python/lib/python3.4/site-packages (from cryptography)
Downloading/unpacking six>=1.4.1 (from cryptography)
  Downloading six-1.10.0-py2.py3-none-any.whl
Requirement already satisfied (use --upgrade to upgrade): setuptools>=11.3 in /usr/local/python/lib/python3.4/site-packages (from cryptography)
Downloading/unpacking cffi>=1.4.1 (from cryptography)
  Downloading cffi-1.7.0.tar.gz (400kB): 400kB downloaded
  Running setup.py (path:/tmp/pip_build_root/cffi/setup.py) egg_info for package cffi

~長くて投稿できないので中略します~

  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 246, in run_setup
    DirectorySandbox(setup_dir).run(runner)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 276, in run
    return func()
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 245, in runner
    _execfile(setup_script, ns)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 47, in _execfile
    exec(code, globals, locals)
  File "/tmp/easy_install-m3_qrp91/cffi-1.7.0/setup.py", line 192, in <module>
    return True
  File "/usr/local/python/lib/python3.4/distutils/core.py", line 163, in setup
    raise SystemExit("error: " + str(msg))
SystemExit: error: command 'gcc' failed with exit status 1

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/command/easy_install.py", line 1100, in run_setup
    run_setup(setup_script, args)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 249, in run_setup
    raise
  File "/usr/local/python/lib/python3.4/contextlib.py", line 77, in __exit__
    self.gen.throw(type, value, traceback)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 197, in setup_context
    yield
  File "/usr/local/python/lib/python3.4/contextlib.py", line 77, in __exit__
    self.gen.throw(type, value, traceback)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 168, in save_modules
    saved_exc.resume()
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 143, in resume
    six.reraise(type, exc, self._tb)
  File "/usr/local/python/lib/python3.4/site-packages/pkg_resources/_vendor/six.py", line 685, in reraise
    raise value.with_traceback(tb)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 156, in save_modules
    yield saved
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 197, in setup_context
    yield
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 246, in run_setup
    DirectorySandbox(setup_dir).run(runner)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 276, in run
    return func()
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 245, in runner
    _execfile(setup_script, ns)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/sandbox.py", line 47, in _execfile
    exec(code, globals, locals)
  File "/tmp/easy_install-m3_qrp91/cffi-1.7.0/setup.py", line 192, in <module>
    return True
  File "/usr/local/python/lib/python3.4/distutils/core.py", line 163, in setup
    raise SystemExit("error: " + str(msg))
SystemExit: error: command 'gcc' failed with exit status 1

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "<string>", line 1, in <module>
  File "/tmp/pip_build_root/cryptography/setup.py", line 333, in <module>
    **keywords_with_side_effects(sys.argv)
  File "/usr/local/python/lib/python3.4/distutils/core.py", line 108, in setup
    _setup_distribution = dist = klass(attrs)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/dist.py", line 279, in __init__
    self.fetch_build_eggs(attrs['setup_requires'])
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/dist.py", line 323, in fetch_build_eggs
    replace_conflicting=True,
  File "/usr/local/python/lib/python3.4/site-packages/pkg_resources/__init__.py", line 826, in resolve
    dist = best[req.key] = env.best_match(req, ws, installer)
  File "/usr/local/python/lib/python3.4/site-packages/pkg_resources/__init__.py", line 1092, in best_match
    return self.obtain(req, installer)
  File "/usr/local/python/lib/python3.4/site-packages/pkg_resources/__init__.py", line 1104, in obtain
    return installer(requirement)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/dist.py", line 390, in fetch_build_egg
    return cmd.easy_install(req)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/command/easy_install.py", line 664, in easy_install
    return self.install_item(spec, dist.location, tmpdir, deps)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/command/easy_install.py", line 694, in install_item
    dists = self.install_eggs(spec, download, tmpdir)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/command/easy_install.py", line 875, in install_eggs
    return self.build_and_install(setup_script, setup_base)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/command/easy_install.py", line 1114, in build_and_install
    self.run_setup(setup_script, setup_base, args)
  File "/usr/local/python/lib/python3.4/site-packages/setuptools/command/easy_install.py", line 1102, in run_setup
    raise DistutilsError("Setup script exited with %s" % (v.args[0],))
distutils.errors.DistutilsError: Setup script exited with error: command 'gcc' failed with exit status 1
Cleaning up...
Command /usr/local/bin/python -c "import setuptools, tokenize;__file__='/tmp/pip_build_root/cryptography/setup.py';exec(compile(getattr(tokenize, 'open', open)(__file__).read().replace('\r\n', '\n'), __file__, 'exec'))" install --record /tmp/pip-dogbba2h-record/install-record.txt --single-version-externally-managed --compile failed with error code 1 in /tmp/pip_build_root/cryptography
Storing debug log for failure in /root/.pip/pip.log

試したこと

エラーが多くて何が問題かが分からないので、
"--compile failed with error code 1"の辺りに着目してweb検索して調べました。

https://teratail.com/questions/4839 を参考にして、
yum install gcc gcc-c++ kernel-devel
yum install python-devel
yum install libxslt-devel
をインストールしていますが、上記のエラーの状態です。

補足情報

OS:CentOS
python3.4.1

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

checkベストアンサー

+1

pipでのインストールは、モジュールによってはこのようにビルドでハマってしまいますので、
Anacondaを導入された方が良いかも知れません。
cryptographyはAnacondaに入っています。

paramikoは入っていないので、それは改めて別途インストールしてください。

詳しくは、下記の質問を参考にしてください。

Python 3.x - virtualenvにモジュールがインストールできません。(41398)|teratail  
https://teratail.com/questions/41398

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2016/07/18 18:16

    頂いたリンクをもとに、Anacondaのインストール+paramikoのインストールで、
    解決しました。ありがとうございます。
    http://qiita.com/y__sama/items/5b62d31cb7e6ed50f02c

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.52%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る